import java.util.*;
import java.io.*;

class Ants {

	private static final boolean DEBUG = true;

	public static void main( String[] args ) throws Exception {
		final BufferedReader br = new BufferedReader( new InputStreamReader( System.in ) );
		String line = br.readLine();
		String[] p;
		while ( line != null ) {
			p = line.split( " " );
			int l = Integer.parseInt( p[0] );
			int a = Integer.parseInt( p[1] );
			System.out.println( String.format("DEBUG: l=%d, a=%d", l, a) );
			ArrayList<Ant> ants = new ArrayList<Ant>();
			for ( int i = 0; i < a; ++i ) {
				line = br.readLine();
				//System.out.println( "DEBUG: " + line );
				p = line.split( " " );
				ants.add( new Ant( Integer.parseInt(p[0]), p[1].charAt(0) ) );
			}
			Collections.sort( ants );
			
			int time = -1;
			int a1pos = -1;
			int a2pos = -1;
			int n = ants.size();
			ArrayList<Ant> nants = new ArrayList<Ant>();
			for ( int i = 0; i < n; ++i ) {
				Ant ant = ants.get(i);
				if ( ant.dir == 'L' ) {
					int tmp = ant.pos;
					if ( tmp  == time ) {
						a2pos = ant.pos;
					}
					if ( tmp > time ) {
						time = tmp;
						a1pos = ant.pos;
						a2pos = -1;
					} 
				} else {
					nants.add( ant ); // copy to new list
					for ( int j = i+1; j < n; ++j ) { nants.add( ants.get(j)); }
					break;
				}
			}
			ants = nants;
			n = ants.size();

			// remove those walking right
			nants = new ArrayList<Ant>();
			for ( int i = n-1; i >= 0; --i ) {
				Ant ant = ants.get(i);
				if ( ant.dir == 'R' ) {
					int tmp = l - ant.pos;
					if ( tmp == time ) {
						a2pos = ant.pos;
					}
					if ( tmp > time ) {
						time = tmp;
						a1pos = ant.pos;
						a2pos = -1;
					} 
				} else {
					nants.add( ant ); // copy to new list
					for ( int j = i-1; j >= 0; --j ) { nants.add( ants.get(j)); }
					break;
				}
			}
			ants = nants;
			n = ants.size();

			if ( n == 0 ) {
				if ( a2pos != -1 ) System.out.println( String.format("The last ant will fail down in %d seconds - started at %d and %d.", time, a1pos, a2pos ));
				else System.out.println( String.format( "The last ant will fail down in %d seconds - started at %d.", time, a1pos ) );
				line = br.readLine();
				continue;
			}

			Collections.sort( ants );
			n = ants.size();
			while ( true ) {
				if (DEBUG) System.out.println( "DEBUG: ants - " + ants );
				
				int fd = ants.get(1).pos - ants.get(0).pos;				
				int ld = ants.get(n-1).pos - ants.get(n-2).pos;
				if ( fd + ants.get(0).pen < ld + ants.get(n-1).pen ) {
					ants.get(1).pen = ants.get(0).pen + fd;
					ants.remove(0);
					n = ants.size();
				}
				if ( fd + ants.get(0).pen > ld + ants.get(n-1).pen ) {
					ants.get(n-2).pen = ants.get(n-1).pen + ld;
					ants.remove(n-1);
					n = ants.size();
				}
				if ( n > 2 && fd + ants.get(0).pen == ld + ants.get(n-1).pen ) {
					ants.get(1).pen = ants.get(0).pen + fd;
					ants.remove(0);
					n = ants.size();
					
					ants.get(n-2).pen = ants.get(n-1).pen + ld;
					ants.remove(n-1);
					n = ants.size();
				}
				n = ants.size();
				if ( n == 2 ) { 
					System.out.println( String.format("The last ant will fail down in %d seconds - started at %d and %d.", ants.get(0).pen + ants.get(0).pos, ants.get(0).pos, ants.get(1).pos ));
					line = br.readLine();
					break;
				} else if ( n == 1 ) {
					System.out.println( String.format( "The last ant will fail down in %d seconds - started at %d.", ants.get(0).pen + ants.get(0).pos, ants.get(0).pos ) );
					line = br.readLine();
					break;
				}
			}
		}
	}

	private static class Ant implements Comparable<Ant> {
		int pos;
		int pen;
		char dir;
		
		Ant( int p, char d ) { pos = p; dir = d; pen = 0; }

		public int compareTo( Ant a ) {
			if ( a.pos == this.pos ) {
				if ( this.dir == 'L' ) return -1;
				else return 1;
			}
			return this.pos < a.pos ? -1 : 1;
		}

		public String toString() {
			boolean d = DEBUG;
			return String.format( "[pos=%d, pen=%d]", pos, pen );
		}

	}

}
